#-----------------------------------------------------------------------------
%{?!dist:	%define	dist		.ok}
%global		homedir			/opt			
%global		appname			%{name}
#-----------------------------------------------------------------------------
Name		:	librenms
Version		:	24.4.1
Release		:	17.0.10.rel%{?dist}

Summary		:	auto-discovering PHP/MySQL/SNMP based network monitoring 

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv3
URL		:	https://github.com/librenms/librenms

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
#-----------------------------------------------------------------------------
BuildRequires	:	php-cli
BuildRequires	:	php-gd
BuildRequires	:	php-pdo
BuildRequires	:	php-xml
BuildRequires	:	wget

Requires	:	acl
Requires	:	bash-completion
Requires	:	fping
Requires	:	ImageMagick
Requires	:	mariadb
Requires	:	net-snmp
Requires	:	net-snmp-utils
Requires	:	nmap
Requires	:	nginx
Requires	:	python3-certbot-nginx
Requires	:	perl-JSON
Requires	:	perl-Mail-Sender
Requires	:	perl-Perl4-CoreLibs
Requires	:	perl-TermReadKey
Requires	:	php-pdo
Requires	:	php-gd
Requires	:	php-gmp
Requires	:	php-mysqlnd
Requires	:	php-snmp
Requires	:	php-xml
Requires	:	python-dotenv
Requires	:	python-redis
Requires	:	python3-command_runner
Requires	:	python3-pip
Requires	:	python3-psutil
Requires	:	python3-PyMySQL
Requires	:	python3-setuptools
Requires	:	rrdtool
Requires	:	shadow


Buildarch	:	noarch

#-----------------------------------------------------------------------------
%description
LibreNMS is an auto-discovering PHP/MySQL/SNMP based
 network monitoring which includes support for a
wide range of network hardware and operating systems
including Cisco, Linux, FreeBSD, Juniper, Brocade,
Foundry, HP and many more.

#-----------------------------------------------------------------------------
%files
%defattr(-,%{appname},%{appname},-)
%license LICENSE.txt
%config (noreplace) %{_sysconfdir}/php/php-fpm.d/fpm-%{name}.conf
%config (noreplace) %{_sysconfdir}/mysql/my.cnf.d/%{name}.cnf
%config (noreplace) %{_sysconfdir}/mysql/%{name}.db
%config (noreplace) %{_sysconfdir}/mysql/%{name}-time.db
%config (noreplace) %attr(-,root,root) %{_sysconfdir}/cron.d/%{name}.cron
%config (noreplace) %attr(-,root,root) %{_sysconfdir}/cron.d/%{name}-scheduler.cron
%config (noreplace) %attr(-,root,root) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/nginx/conf.d/nginx-%{name}.conf.example
%{_bindir}/lnms
%dir %{homedir}/%{name}/rrd/
%dir %{homedir}/%{name}/logs/
%{homedir}/%{name}/AUTHORS.md
%{homedir}/%{name}/CHANGELOG.md
%{homedir}/%{name}/CODE_OF_CONDUCT.md
%{homedir}/%{name}/CONTRIBUTING.md
%{homedir}/%{name}/LICENSE.txt
%{homedir}/%{name}/README.md
%{homedir}/%{name}/SECURITY.md
%{homedir}/%{name}/artisan
%{homedir}/%{name}/composer.phar
%{homedir}/%{name}/cronic
%{homedir}/%{name}/lnms
%{homedir}/%{name}/requirements.txt
%{homedir}/%{name}/.codeclimate.yml
%{homedir}/%{name}/.editorconfig
%config (noreplace) %{homedir}/%{name}/.env
%{homedir}/%{name}/.env.*
%{homedir}/%{name}/.git-blame-ignore-revs
%{homedir}/%{name}/.php-cs-fixer.php
%{homedir}/%{name}/.scrutinizer.yml
%{homedir}/%{name}/.styleci.yml
%{homedir}/%{name}/*.default
%{homedir}/%{name}/*.example
%{homedir}/%{name}/*.js
%{homedir}/%{name}/*.json
%{homedir}/%{name}/*.lock
%{homedir}/%{name}/*.neon
%{homedir}/%{name}/*.php
%{homedir}/%{name}/*.py
%{homedir}/%{name}/*.sh
%{homedir}/%{name}/*.xml
%{homedir}/%{name}/*.yml
%{homedir}/%{name}/LibreNMS/
%{homedir}/%{name}/app/
%{homedir}/%{name}/bootstrap/
%{homedir}/%{name}/config/
%{homedir}/%{name}/database/
%{homedir}/%{name}/dist/
%{homedir}/%{name}/doc/
%{homedir}/%{name}/html/
%{homedir}/%{name}/includes/
%{homedir}/%{name}/lang/
%{homedir}/%{name}/licenses/
%{homedir}/%{name}/logs/%{name}.log
%{homedir}/%{name}/mibs/
%{homedir}/%{name}/misc/
%{homedir}/%{name}/resources/
%{homedir}/%{name}/routes/
%{homedir}/%{name}/tests/
%{homedir}/%{name}/storage/
%{homedir}/%{name}/scripts/
%{homedir}/%{name}/vendor/

#-----------------------------------------------------------------------------
%pre
#after upgrade or remove
if [ "$1" = 1 ]; then
  if [ ! $(getent group %{appname}) ]; then
    /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{appname}
    /usr/sbin/useradd 				\
	-r					\
	-c "%{name} application"		\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{appname}				\
	-s /usr/bin/bash			\
	-d %{homedir}/%{name}			\
	%{appname}
    fi
  fi

#-----------------------------------------------------------------------------
%post
if [ "$1" = 1 ]; then
  #starting/restarting mysql
  %{_sysconfdir}/rc.d/init.d/mysqld restart > /dev/null 2>&1
  sleep 5	#making sure the mysqld daemon is up and running
  %{_sysconfdir}/rc.d/init.d/mysqld status
  if [ "$?" = "0" ] ; then
    #creating the database
    cat %{_sysconfdir}/mysql/%{name}.db | mysql
    #startin/restarting fpm server
    %{_sysconfdir}/rc.d/init.d/php-fpm restart > /dev/null 2>&1
    else
    echo "Unable to create the %{name} database within MySQL"
    fi
  fi

#-----------------------------------------------------------------------------
%postun
if [ "$1" = 0 ]; then
  /usr/sbin/userdel %{appname}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

#=============================================================================
%prep
%setup -q 
tar xf %{SOURCE1}

#-----------------------------------------------------------------------------
#building application
%build
%{__rm} -fr ../%{name}-ok_addon
%{__mv} %{name}-ok_addon ..
./scripts/composer_wrapper.php install --no-dev

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install


%{__mkdir_p} %{buildroot}%{homedir}/%{name}
%{__cp} -a						\
	.						\
	%{buildroot}%{homedir}/%{name}


%{__rm} -f						\
	%{buildroot}%{homedir}/%{name}/storage/logs/.gitignore

find %{buildroot} -name ".gitignore" | xargs rm -f
find %{buildroot} -name ".github" | xargs rm -fr

#setting the NGINX configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/nginx/conf.d
%{__cp} -a						\
	../%{name}-ok_addon/nginx-%{name}.conf.example	\
	%{buildroot}%{_sysconfdir}/nginx/conf.d/
sed -i							\
 -e "s:/opt/:%{homedir}/:g"				\
 %{buildroot}%{_sysconfdir}/nginx/conf.d/nginx-%{name}.conf.example
	
#setting the rrdtool directory
%{__mkdir_p} %{buildroot}%{homedir}/%{name}/rrd

#setting the php-fpm configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/php/php-fpm.d
%{__cp} -a						\
	../%{name}-ok_addon/fpm-%{name}.conf		\
	%{buildroot}%{_sysconfdir}/php/php-fpm.d/

#setting the cron configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/cron.d
%{__cp} -a						\
	dist/%{name}.cron				\
	dist/%{name}-scheduler.cron			\
	%{buildroot}%{_sysconfdir}/cron.d/

sed -i							\
 -e "s:/opt/:%{homedir}/:g"				\
 -e "s:^19   0:#19   0:"				\
 -e "s: php : %{name} :g"				\
 %{buildroot}%{_sysconfdir}/cron.d/%{name}.cron		\
 %{buildroot}%{_sysconfdir}/cron.d/%{name}-scheduler.cron

#setting the mysql configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/mysql/my.cnf.d
%{__cp} -a						\
	../%{name}-ok_addon/mysql-%{name}.cnf		\
	%{buildroot}%{_sysconfdir}/mysql/my.cnf.d/%{name}.cnf
%{__cp} -a						\
	../%{name}-ok_addon/mysql-%{name}.db		\
	%{buildroot}%{_sysconfdir}/mysql/%{name}.db
%{__cp} -a						\
	../%{name}-ok_addon/mysql-%{name}-time.db	\
	%{buildroot}%{_sysconfdir}/mysql/%{name}-time.db

#setting the log rotatation configuration file
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d/
%{__cp} -a						\
	misc/%{name}.logrotate				\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}
sed -i							\
 -e "s:/opt/:%{homedir}/:g"				\
  %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#cleaning build log
echo > %{buildroot}%{homedir}/%{name}/logs/%{name}.log

#set binary nms
%{__mkdir_p} %{buildroot}%{_bindir}
%{__ln_s}						\
	../../%{homedir}/%{name}/lnms			\
	%{buildroot}%{_bindir}/lnms
	
#cleaning upstream addon
%{__rm} -fr ../%{name}-ok_addon

#%{__rm} -f						\
#	%{buildroot}/%{homedir}/%{name}/.[a-z]*

#-----------------------------------------------------------------------------
%changelog
